'use strict';

var domjs  = require('./domjs')
  , call   = require('es5-ext/lib/Function/call')
  , extend = require('es5-ext/lib/Object/extend').call

  , html5js;

html5js = Object.freeze(extend(Object.create(domjs), {
	setAttribute: function (parent, el, name, value) {
		if (name.slice(0,2) === 'on') {
			el[name] = value;
		} else {
			parent(this, el, name, value);
		}
	}
}).init(['a', 'abbr', 'address', 'area', 'article', 'aside', 'audio',
	'b', 'bdi', 'bdo', 'blockquote', 'br', 'button', 'canvas', 'caption', 'cite',
	'code', 'col', 'colgroup', 'command', 'datalist', 'dd', 'del', 'details',
	'device','dfn', 'div', 'dl', 'dt', 'em', 'embed', 'fieldset', 'figcaption',
	'figure', 'footer', 'form', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'header',
	'hgroup', 'hr', 'i', 'iframe', 'img', 'input', 'ins', 'kbd', 'keygen',
	'label', 'legend', 'li', 'link', 'map', 'mark', 'menu', 'meter', 'nav',
	'noscript', 'object', 'ol', 'optgroup', 'option', 'output', 'p', 'param',
	'pre', 'progress', 'q', 'rp', 'rt', 'ruby', 's', 'samp', 'script', 'section',
	'select', 'small', 'source', 'span', 'strong', 'style', 'sub', 'summary',
	'sup', 'table', 'tbody', 'td', 'textarea', 'tfoot', 'th', 'thead', 'time',
	'tr', 'track', 'ul', 'var', 'video', 'wbr']));

module.exports = function (document) {
	var builder = Object.create(html5js).init(document);

	return function (f) {
		return builder.build(f);
	};
};
